<?php

class Tx_Powermailpdf_Pdf extends Tx_Powermail_Controller_FormsController {
		
	/**
	 *
	 * @param array $field
	 * @return path to pdf
	 * This function is used when pdftk is NOT installed on system
	 * Remember: No chockboxes possible
	 */
	function generate_pdf($field){
		require 'Service/fpdm.php';
		//ToDo Map Fields from $field to array;
		//Normal Fields
		$fieldMap= $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['fieldMap.'];
		
		foreach ($fieldMap as $key => $value) {
			$fdf_data_strings[$key]  = $field[$value];
		}
		
		//$pdf_original = \TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName($GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['sourceFile']);
		$pdf_original = t3lib_div::getFileAbsFileName($GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['sourceFile']);
		if (isset($pdf_original)){
			// Name of file to be downloaded
			$downloadLink = 'uploads/tx_powermailpdf/'.md5(time()).'.pdf';
			$pdf_filename = PATH_site.$downloadLink;
			$pdf = new FPDM($pdf_original);
			$pdf->Load($fdf_data_strings, true); // second parameter: false if field values are in ISO-8859-1, true if UTF-8
			$pdf->Merge();
			$pdf->Output($pdf_filename, "");
		}else{
			//@ToDO some Error
		}
		
		return $downloadLink;
		
	}
	
	/**
	 * 
	 * @param array $field
	 * @return path to pdf
	 * This function is used when pdftk is installed on system
	 */
	
	function generate_pdf_pdftk($field){
		require 'Service/pdftk-php.php';
		
		// Initiate the class
		$pdfmaker = new pdftk_php;
		
		// Define variables for all the data fields in the PDF form. You need to assign a column in the database to each field that you'll be using in the PDF.
		// Example:
		// $pdf_column = $data['column'];
		
		// You can also format the MySQL data how you want here. One common example is formatting a date saved in the database. For example:
		// $pdf_date = date("l, F j, Y, g:i a", strtotime($data['date']));
		

		
		// $fdf_data_strings associates the names of the PDF form fields to the PHP variables you just set above. In order to work correctly the PDF form field name has to be exact. PDFs made in Acrobat generally have simpler names - just the name you assigned to the field. PDFs made in LiveCycle Designer nest their forms in other random page elements, creating a long and hairy field name. You can use pdftk to discover the real names of your PDF form fields: run "pdftk form.pdf dump_data_fields > form-fields.txt" to generate a report.
		
		// Example of field names from a PDF created in LiveCycle:
		// $fdf_data_strings= array('form1[0].#subform[0].#area[0].LastName[0]' => $pdf_lastname,  'form1[0].#subform[0].#area[0].FirstName[0]' => $pdf_firstname, 'form1[0].#subform[0].#area[0].EMail[0]' => $pdf_email, );
		#$fdf_data_strings= array('E-Mail' => $pdf_firstname,  'Fax' => $pdf_lastname);
		$fdf_data_strings=$GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['fieldMap.'];
		
		// See the documentation of pdftk-php.php for more explanation of these other variables.
		
		// Used for radio buttons and check boxes
		// Example: (For check boxes options are Yes and Off)
		// $pdf_checkbox1 = "Yes";
		// $pdf_checkbox2 = "Off";
		// $pdf_checkbox3 = "Yes";
		// $fdf_data_names = array('checkbox1' => $pdf_checkbox1,'checkbox2' => $pdf_checkbox2,'checkbox3' => $pdf_checkbox3,'checkbox4' => $pdf_checkbox4);
		$fdf_data_names = array(); // Leave empty if there are no radio buttons or check boxes
		$fdf_data_names = array('Einverst'.chr(228).'ndnis-Checkbox'    => 'Nein', 'Preis1'    => 'Nein', 'Preis2'    => 'Nein', 'Preis3' => 'Ja');
		
		$fields_hidden = array(); // Used to hide form fields
		
		$fields_readonly = array(); // Used to make fields read only - however, flattening the output with pdftk will in effect make every field read only. If you don't want a flattened pdf and still want some read only fields, use this variable and remove the flatten flag near line 70 in pdftk-php.php
		
		// Name of file to be downloaded
		$pdf_filename = "Test PDF for $pdf_firstname $pdf_lastname.pdf";
		
		// Name/location of original, empty PDF form
		$pdf_original = "source2.pdf";
		
		// Finally make the actual PDF file!
		$pdfmaker->make_pdf($fdf_data_strings, $fdf_data_names, $fields_hidden, $fields_readonly, $pdf_original, $pdf_filename);
		
		
	}
	
	/**
	 * @param string $uri the URI that will be put in the href attribute of the rendered link tag
	 * @param string $label
	 * @return string Rendered link
	 */
	
	public function render($uri, $label) {
	
		//get filelinkconf from typoscript setup plugin.tx_productdownloads.settings.filelink
		$filelinkconf = $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.']['filelink.'];
	
		//replace the link label with the param $label
		$filelinkconf['labelStdWrap.']['cObject'] = 'TEXT';
		$filelinkconf['labelStdWrap.']['cObject.']['value'] = $label;
		
		$output = $GLOBALS['TSFE']->cObj->filelink($uri,$filelinkconf);
		return $output;
	}
	
	function main($field,$form,$mail,$controller, $object) {
		$settings = $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.'];
		if($settings['enablePowermailPdf']){
			$powermailSettings = $controller->settings;
			//$settings = $this->configurationManager->getConfiguration(\TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface::CONFIGURATION_TYPE_SETTINGS, 'powermailpdf', 'pi1');
			$this->field = array();
			
			if($settings['fillPdf']){
				$file = $this->generate_pdf($controller->div->getVariablesWithMarkers($field));
			}else{
				$file = $settings['sourceFile'];
			}
			$this->signalSlotDispatcher->dispatch(__CLASS__, __FUNCTION__ . 'File', array(&$file, $this));


			
			//Should an email be send
			if($settings['sendEmail']){
				if($powermailSettings['receiver']['subject']){
					$receiverString = $controller->div->fluidParseString($powermailSettings['receiver']['email'], $this->objectManager, $controller->div->getVariablesWithMarkers($field));
					$receivers = $controller->div->getReceiverEmails($receiverString, $powermailSettings['receiver']['fe_group']);
					if ($controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['email'], $controller->conf['receiver.']['overwrite.']['email.'])) { // overwrite from typoscript
						$receivers = t3lib_div::trimExplode(',', $controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['email'], $controller->conf['receiver.']['overwrite.']['email.']), 1);
					}
					foreach ($receivers as $receiver) {
						$mail = array();
						$mail['receiverName'] = $powermailSettings['receiver']['name'] ? $powermailSettings['receiver']['name'] : 'Powermail';
						$mail['receiverEmail'] = $receiver;
						$mail['senderName'] = $controller->div->getSenderNameFromArguments($field);
						$mail['senderEmail'] = $controller->div->getSenderMailFromArguments($field);
						$mail['subject'] = $powermailSettings['receiver']['subject'];
						$mail['template'] = 'Mails/ReceiverMail';
						$mail['rteBody'] = $powermailSettings['receiver']['body'];
						$mail['format'] = $powermailSettings['receiver']['mailformat'];
						$mail['attachments'] = array(t3lib_div::getFileAbsFileName($file));
						if ($controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['name'], $controller->conf['receiver.']['overwrite.']['name.'])) { // overwrite from typoscript
							$mail['receiverName'] = $controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['name'], $controller->conf['receiver.']['overwrite.']['name.']);
						}
						if ($controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['senderName'], $controller->conf['receiver.']['overwrite.']['senderName.'])) { // overwrite from typoscript
							$mail['senderName'] = $controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['senderName'], $controller->conf['receiver.']['overwrite.']['senderName.']);
						}
						if ($controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['senderEmail'], $controller->conf['receiver.']['overwrite.']['senderEmail.'])) { // overwrite from typoscript
							$mail['senderEmail'] = $controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['senderEmail'], $controller->conf['receiver.']['overwrite.']['senderEmail.']);
						}
						$this->sendTemplateEmail($mail, $field, $controller);
					
						if (!$sent) {
							$this->flashMessageContainer->add(Tx_Extbase_Utility_Localization::translate('error_mail_not_created', 'powermail'));
							$this->messageClass = 'error';
						}
					}
				}

				if($powermailSettings['sender']['subject']){
					// Send Mail to sender
					$mail = array();
					$mail['receiverName'] = $controller->div->getSenderNameFromArguments($field) ? $controller->div->getSenderNameFromArguments($field) : 'Powermail';
					$mail['receiverEmail'] = $controller->div->getSenderMailFromArguments($field);
					$mail['senderName'] = $powermailSettings['sender']['name'];
					$mail['senderEmail'] = $powermailSettings['sender']['email'];
					$mail['subject'] = $powermailSettings['sender']['subject'];
					$mail['template'] = 'Mails/SenderMail';
					$mail['rteBody'] = $powermailSettings['sender']['body'];
					$mail['format'] = $powermailSettings['sender']['mailformat'];
					$mail['attachments'] = array(t3lib_div::getFileAbsFileName($file));
					if ($controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['email'], $controller->conf['sender.']['overwrite.']['email.'])) { // overwrite from typoscript
						$mail['receiverEmail'] = $controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['email'], $controller->conf['sender.']['overwrite.']['email.']);
					}
					if ($controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['name'], $controller->conf['sender.']['overwrite.']['name.'])) { // overwrite from typoscript
						$mail['receiverName'] = $controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['name'], $controller->conf['sender.']['overwrite.']['name.']);
					}
					if ($controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['senderName'], $controller->conf['sender.']['overwrite.']['senderName.'])) { // overwrite from typoscript
						$mail['senderName'] = $controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['senderName'], $controller->conf['sender.']['overwrite.']['senderName.']);
					}
					if ($controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['senderEmail'], $controller->conf['sender.']['overwrite.']['senderEmail.'])) { // overwrite from typoscript
						$mail['senderEmail'] = $controller->cObj->cObjGetSingle($controller->conf['sender.']['overwrite.']['senderEmail'], $controller->conf['sender.']['overwrite.']['senderEmail.']);
					}
					$this->sendTemplateEmail($mail, $field, $controller);
				}
				
			}
			
			//Show download link in submit page
			if($settings['showDownloadLink']){
				$label= Tx_Extbase_Utility_Localization::translate("download","powermailpdf");
				$link=$this->render($file, $label);
				$controller->view->assign('powermailpdf_link', $link);
			}
		}
	}
	
	/**
	* @param array $mail Array with all needed mail information
	 * 		$mail['receiverName'] = 'Name';
	 * 		$mail['receiverEmail'] = 'receiver@mail.com';
	 *		$mail['senderName'] = 'Name';
	 * 		$mail['senderEmail'] = 'sender@mail.com';
	 * 		$mail['subject'] = 'Subject line';
	 * 		$mail['template'] = 'PathToTemplate/';
	 * 		$mail['rteBody'] = 'This is the <b>content</b> of the RTE';
	 * 		$mail['format'] = 'both'; // or plain or html
	 * 		$mail['attachments'] = array
	 * @param array $sender sender of the email in the format array('sender@domain.tld' => 'Sender Name')
	 * @param string $subject subject of the email
	 * @param string $templateName template name (UpperCamelCase)
	 * @param array $variables variables to be passed to the Fluid view
	 * @param Object $controller the powermail controller
	 * @return boolean TRUE on success, otherwise false
	 */
	protected function sendTemplateEmail(array $mail, array $variables = array(), $controller) {
		$PowermailPdfSettings = $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_powermailpdf.']['settings.'];
		
		
		// parsing variables with fluid engine to allow viewhelpers and variables in some flexform fields
		$parse = array(
				'receiverName',
				'receiverEmail',
				'senderName',
				'senderEmail',
				'subject'
		);
		
		$extbaseFrameworkConfiguration = $this->configurationManager->getConfiguration(Tx_Extbase_Configuration_ConfigurationManagerInterface::CONFIGURATION_TYPE_FRAMEWORK);
		$templatePathAndFilename = t3lib_div::getFileAbsFileName($extbaseFrameworkConfiguration['view']['templateRootPath']) . $mail['template']. '.html';
		$emailView = $this->objectManager->create('Tx_Fluid_View_StandaloneView');
		$emailView->getRequest()->setControllerExtensionName('Powermail'); // extension name for translate viewhelper
		$emailView->getRequest()->setPluginName('Pi1');
		$emailView->getRequest()->setControllerName('Forms');
		$emailView->setFormat('html');
		$emailView->setTemplatePathAndFilename($templatePathAndFilename);
		$emailView->setPartialRootPath(t3lib_div::getFileAbsFileName($extbaseFrameworkConfiguration['view']['partialRootPath']));
		$emailView->setLayoutRootPath(t3lib_div::getFileAbsFileName($extbaseFrameworkConfiguration['view']['layoutRootPath']));
		
		
	
		
		// markers in HTML Template
		$variablesWithMarkers = $controller->div->getVariablesWithMarkers($variables);
		$this->signalSlotDispatcher->dispatch(__CLASS__, __FUNCTION__ . 'VariablesWithMarkers', array(&$variablesWithMarkers, $this));
		$emailView->assign('variablesWithMarkers', $controller->div->htmlspecialcharsOnArray($variablesWithMarkers));
		$emailView->assignMultiple($variablesWithMarkers);
		
		// powermail_all
		$pvariables = $controller->div->getVariablesWithLabels($variables);
		
		//@TODO not working properly no link is created
		if($PowermailPdfSettings['email.']['showDownloadLink']){
			foreach ($mail['attachments'] as $attachment) {
				$pvariables[] = array("label" => "Download", "value" => $attachment, "uid" => 666);
			}
		}
		
		$content = $controller->div->powermailAll($pvariables, $this->configurationManager, $this->objectManager, 'mail', $settings);
		$emailView->assign('powermail_all', $content);

		// from rte
		if($PowermailPdfSettings['email.']['showDownloadLink']){
			foreach ($mail['attachments'] as $attachment) {
				$baseUrl = $GLOBALS['TSFE']->baseUrl;
				if(substr($baseUrl, -1, 1)=="/"){
					$mail['rteBody'].= '<a href="' . $baseUrl . substr($attachment, strlen(PATH_site)) . '">Download</a>';
				}else{
					$mail['rteBody'].= '<a href="' . $baseUrl . '/' . substr($attachment, strlen(PATH_site)) . '">Download</a>';
				}
				
			}
		}

		$emailView->assign('powermail_rte', $mail['rteBody']);
		$variablesWithLabels = $controller->div->getVariablesWithLabels($variables);
		
		$emailView->assign('variablesWithLabels', $variablesWithLabels);
		$emailBody = $emailView->render();
		
		/** @var $message \TYPO3\CMS\Core\Mail\MailMessage */
		//$message = $this->objectManager->get('TYPO3\CMS\Core\Mail\MailMessage');
		// Beeing 4.7 compatible
		$message = t3lib_div::makeInstance('t3lib_mail_Message');
		$message
			->setTo(array($mail['receiverEmail'] => $mail['receiverName']))
			->setFrom(array($mail['senderEmail'] => $mail['senderName']))
			->setSubject($mail['subject'])
			->setCharset($GLOBALS['TSFE']->metaCharset);
		$message->setSubject($this->div->fluidParseString($mail['subject'], $this->objectManager, $this->div->getVariablesWithMarkers($variables)));

		// add bcc receivers
		if ($controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['bcc'], $this->conf['receiver.']['overwrite.']['bcc.'])) {
			$bccArray = t3lib_div::trimExplode(',', $controller->cObj->cObjGetSingle($controller->conf['receiver.']['overwrite.']['bcc'], $controller->conf['receiver.']['overwrite.']['bcc.']), 1);
			$message->setBcc($bccArray);
		}
		//Attach file to mail
		//Use own mailer here
		if($PowermailPdfSettings['email.']['attachFile']){
			if(is_array($mail['attachments'])){
				// Possible attachments here
				foreach ($mail['attachments'] as $attachment) {
					$message->attach(Swift_Attachment::fromPath($attachment));
				}
			}else{
				$message->attach(Swift_Attachment::fromPath($attachment));
			}
		}
	
		if ($mail['format'] != 'plain') {
			$message->setBody($emailBody, 'text/html');
		}
		if ($mail['format'] != 'html') {
			$message->addPart($this->makePlain($emailBody), 'text/plain');
		}
		
		$message->send();
		
		return $message->isSent();
	}
	
	/*
	 * These functions are needed because they are defined protected in powermail div
	 * and cannot be called here
	 */
	
	/**
	 * Function makePlain() removes html tags and add linebreaks
	 * 		Easy generate a plain email bodytext from a html bodytext
	 *
	 * @param string $content: HTML Mail bodytext
	 * @return string $content: Plain Mail bodytext
	 */
	protected function makePlain($content) {
		// config
		$htmltagarray = array ( // This tags will be added with linebreaks
				'</p>',
				'</tr>',
				'</li>',
				'</h1>',
				'</h2>',
				'</h3>',
				'</h4>',
				'</h5>',
				'</h6>',
				'</div>',
				'</legend>',
				'</fieldset>',
				'</dd>',
				'</dt>'
		);
		$notallowed = array ( // This array contains not allowed signs which will be removed
				'&nbsp;',
				'&szlig;',
				'&Uuml;',
				'&uuml;',
				'&Ouml;',
				'&ouml;',
				'&Auml;',
				'&auml;',
		);
	
		// let's go
		$content = nl2br($content);
		$content = str_replace($htmltagarray, $htmltagarray[0] . '<br />', $content); // 1. add linebreaks on some parts (</p> => </p><br />)
		$content = strip_tags($content, '<br><address>'); // 2. remove all tags but not linebreaks and address (<b>bla</b><br /> => bla<br />)
		$content = preg_replace('/\s+/', ' ', $content); // 3. removes tabs and whitespaces
		$content = $this->br2nl($content); // 4. <br /> to \n
		$content = implode("\n", t3lib_div::trimExplode("\n", $content)); // 5. explode and trim each line and implode again (" bla \n blabla " => "bla\nbla")
		$content = str_replace($notallowed, '', $content); // 6. remove not allowed signs
	
		return $content;
	}
	
	/**
	 * Function br2nl is the opposite of nl2br
	 *
	 * @param string $content: Anystring
	 * @return string $content: Manipulated string
	 */
	protected function br2nl($content) {
		$array = array(
				'<br >',
				'<br>',
				'<br/>',
				'<br />'
		);
		$content = str_replace($array, "\n", $content); // replacer
	
		return $content;
	}
	}
?>
